import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Enemy here.
 * 
 * @author Revernd 
 * @version 20120109
 */
public class Enemy extends Actor
{
    /**
     * Act - do whatever the Enemy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        moveAndTurn();
        eat();
    }
    
    private void moveAndTurn()
    {
        move(1);
        if ( Greenfoot.getRandomNumber(100) < 10 )
        {
            turn( Greenfoot.getRandomNumber(90) - 45 );
        }
        if ( getX() <= 5 || getX() >= getWorld().getWidth() - 5 )
        {
            turn(180);
        }
        if ( getY() <= 5 || getY() >= getWorld().getHeight() - 5 )
        {
            turn(180);
        }
    }
    
    private void eat()
    {
        Actor peep = getOneIntersectingObject(Person.class);
        Actor car = getOneIntersectingObject(Car.class);
        Road road = (Road) this.getWorld();
        Counter score = road.getScore();
        
        if ( peep != null )
        {
            getWorld().removeObject(peep);
            score.bumpCount("Score: ", -1);
        }
        
        if ( car != null )
        {
           for (int i = 0; i < 4; i++)
           {
               car.setImage("ambulance-transparent.png");
               Greenfoot.delay(5);
               car.setImage("ambulance.png");
               Greenfoot.delay(5);
           }
           if ( ((Car)car).getHealth() > 1)
           {
                ((Car)car).removeHealth();
                getWorld().removeObject(this);
           }
           else
           {
               if ( ((Car)car).getHealth() != 0 )
               {
                    ((Car)car).removeHealth();
                    getWorld().addObject(new Display("GAME OVER"), getWorld().getWidth() / 2, getWorld().getHeight() / 2);
               }
               Greenfoot.stop();
           }
        }
    }
}
