import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A person that needs to be run over! (or saved)
 */
public class Person  extends Actor
{

    public Person()
    {
        if ( Greenfoot.getRandomNumber(5) < 1 )
        {
            this.setRotation(180);
        }
    }
    
    /**
     * Act - do whatever the Person wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        int ypos = getY();
        int xpos = getX();
        
        if (  ypos > 0 && ypos < getWorld().getHeight() - 1 && xpos > 0 && xpos < getWorld().getWidth() -1 ) 
        {
            moveAndTurn();
        }
        else 
        {
            this.deleteObject();
        }
    }
    
    private void deleteObject()
    {
        getWorld().removeObject(this);
    }
    
    private void moveAndTurn()
    {
        move(1);
        if ( Greenfoot.getRandomNumber(200) < 10 )
        {
            turn( Greenfoot.getRandomNumber(90) - 45 );
        }
    }
}
